%global momorel 3

Summary: NFS utilities and supporting clients and daemons for the kernel NFS server
Name: nfs-utils
Version: 1.1.4
Release: %{momorel}m%{?dist}

# group all 32bit related archs
%define all_32bit_archs i386 i686 athlon

# Create mount.nfs and umount.nfs binaries that will be
# used by the system mount command to mount (and umount)
# both NFS and NFS4 filesystems.
%define enablemount 0

# Enable the ability to set the 'fsc' mount flag which
# will allow NFS to use FS-Cache.
%define enablefscache 0

URL: http://sourceforge.net/projects/nfs/
Source0: http://dl.sourceforge.net/sourceforge/nfs/nfs-utils-%{version}.tar.bz2
NoSource: 0
Source1: http://dl.sourceforge.net/sourceforge/nfs/nfs.doc.tar.gz

Source10: nfs.init
Source11: nfslock.init
Source12: rpcidmapd.init
Source13: rpcgssd.init
Source14: rpcsvcgssd.init
Source15: nfs.sysconfig

Patch00: nfs-utils-1.0.5-statdpath.patch
Patch01: nfs-utils-1.0.6-mountd.patch
Patch02: nfs-utils-1.0.6-gssd_mixed_case.patch
#Patch03: nfs-utils-1.1.0-showmount-rpcerror.patch
Patch04: nfs-utils-1.1.0-exp-subtree-warn-off.patch
#Patch05: nfs-utils-1.1.0-exportfs-open.patch
#Patch06: nfs-utils-1.1.0-exportfs-man-update.patch
#Patch07: nfs-utils-1.1.2-multi-auth-flavours.patch
Patch8: nfs-utils-1.1.4-tcpwrapper-update.patch
Patch9: nfs-utils-1.1.4-tcpwrap-warn.patch
Patch10: nfs-utils-1.1.4-tcpwrap-hash.patch
Patch11: nfs-utils-1.1.4-tcpwrap-newrules.patch
Patch12: nfs-utils-1.1.4-tcpwrap-cleanup.patch

%if %{enablefscache}
Patch90: nfs-utils-1.1.0-mount-fsc.patch
%endif

Group: System Environment/Daemons
Provides: exportfs    = %{version}-%{release}
Provides: nfsstat     = %{version}-%{release}
Provides: showmount   = %{version}-%{release}
Provides: rpcdebug    = %{version}-%{release}
Provides: rpc.idmapd  = %{version}-%{release}
Provides: rpc.mountd  = %{version}-%{release}
Provides: rpc.nfsd    = %{version}-%{release}
Provides: rpc.statd   = %{version}-%{release}
Provides: rpc.gssd    = %{version}-%{release}
Provides: rpc.svcgssd = %{version}-%{release}
Provides: mount.nfs   = %{version}-%{release}
Provides: mount.nfs4  = %{version}-%{release}
Provides: umount.nfs  = %{version}-%{release}
Provides: umount.nfs4 = %{version}-%{release}
Provides: sm-notify   = %{version}-%{release}
Provides: start-statd = %{version}-%{release}

License: GPL
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: rpcbind, sed, gawk, sh-utils, fileutils, textutils, grep
Requires: modutils >= 2.4.26-9
BuildRequires: nfs-utils-lib-devel >= 1.1.1
BuildRequires: nfs-utils-lib >= 1.1.1
BuildRequires: libevent-devel >= 1.4.1 libgssglue
BuildRequires: krb5-libs >= 1.4 autoconf >= 2.57 openldap-devel >= 2.2
BuildRequires: automake, libtool, keyutils-libs-devel
BuildRequires: tcp_wrappers-devel, e2fsprogs-devel, krb5-devel
BuildRequires: perl
Requires(pre): shadow-utils >= 4.0.3-25
Requires(pre): chkconfig util-linux
Requires(pre): nfs-utils-lib >= 1.1.1 libevent >= 1.4.1 libgssglue

%description
The nfs-utils package provides a daemon for the kernel NFS server and
related tools, which provides a much higher level of performance than the
traditional Linux NFS server used by most users.

This package also contains the showmount program.  Showmount queries the
mount daemon on a remote host for information about the NFS (Network File
System) server on the remote host.  For example, showmount can display the
clients which are mounted on that host.

This package also contains the mount.nfs and umount.nfs program.

%prep
%setup -q
%patch00 -p1
%patch01 -p1
%patch02 -p1
#%%patch03 -p1
%patch04 -p1
#%%patch05 -p1
#%%patch06 -p1
#%%patch07 -p1

%patch8 -p1 -b .tcpwrapper-update~
%patch9 -p1 -b .tcpwrap-warn~

%patch10 -p1 -b .tcpwrap-hash~
%patch11 -p1 -b .tcpwrap-newrules~
%patch12 -p1 -b .tcpwrap-cleanup~

%if %{enablefscache}
%patch90 -p1
%endif

# Remove .orig files
find . -name "*.orig" | xargs rm -f

%build

%ifarch s390 s390x
PIE="-fPIE"
%else
PIE="-fpie"
%endif
export PIE

sh -x autogen.sh

CFLAGS="`echo $RPM_OPT_FLAGS $ARCH_OPT_FLAGS $PIE`"
%configure \
    CFLAGS="$CFLAGS" \
    CPPFLAGS="$DEFINES" \
    LDFLAGS="-pie" \
    --enable-mount

make all

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}{/sbin,/usr/sbin}
mkdir -p %{buildroot}%{_mandir}/{man5,man8}
mkdir -p %{buildroot}{%{_initscriptdir},/etc/sysconfig}
make DESTDIR=%{buildroot} install
install -s -m 755 tools/rpcdebug/rpcdebug %{buildroot}/usr/sbin
install -m 755 %{SOURCE10} %{buildroot}%{_initscriptdir}/nfs
install -m 755 %{SOURCE11} %{buildroot}%{_initscriptdir}/nfslock
install -m 755 %{SOURCE12} %{buildroot}%{_initscriptdir}/rpcidmapd
install -m 755 %{SOURCE13} %{buildroot}%{_initscriptdir}/rpcgssd
install -m 755 %{SOURCE14} %{buildroot}%{_initscriptdir}/rpcsvcgssd
install -m 644 %{SOURCE15} %{buildroot}/etc/sysconfig/nfs

# stop auto start
perl -p -i -e 's@^# chkconfig: (\d+) (\d+) (\d+)$@# chkconfig: - $2 $3@' %{buildroot}%{_initscriptdir}/nfslock
perl -p -i -e 's@^# chkconfig: (\d+) (\d+) (\d+)$@# chkconfig: - $2 $3@' %{buildroot}%{_initscriptdir}/rpcidmapd
perl -p -i -e 's@^# chkconfig: (\d+) (\d+) (\d+)$@# chkconfig: - $2 $3@' %{buildroot}%{_initscriptdir}/rpcgssd

mkdir -p %{buildroot}/var/lib/nfs/rpc_pipefs

touch %{buildroot}/var/lib/nfs/rmtab
mv %{buildroot}/usr/sbin/rpc.statd %{buildroot}/sbin

mkdir -p %{buildroot}/var/lib/nfs/statd/sm
mkdir -p %{buildroot}/var/lib/nfs/v4recovery

%clean
rm -rf %{buildroot}

%pre
# move files so the running service will have this applied as well
for x in gssd svcgssd idmapd ; do
	if [ -f /var/lock/subsys/rpc.$x ]; then
		mv /var/lock/subsys/rpc.$x /var/lock/subsys/rpc$x
	fi
done

/usr/sbin/useradd -l -c "RPC Service User" -r \
        -s /sbin/nologin -u 29 -d /var/lib/nfs rpcuser 2>/dev/null || :
# Define the correct unsigned uid value for 32 or 64 bit archs
%ifarch %{all_32bit_archs}
%define nfsnobody_uid   65534
%else
%define nfsnobody_uid   4294967294
%endif

# If UID 65534 (or 4294967294 64bit archs) is unassigned, create user "nfsnobody"
cat /etc/passwd | cut -d':' -f 3 | grep --quiet %{nfsnobody_uid} 2>/dev/null
if [ "$?" -eq 1 ]; then
	/usr/sbin/useradd -l -c "Anonymous NFS User" -r \
		-s /sbin/nologin -u %{nfsnobody_uid} -d /var/lib/nfs nfsnobody 2>/dev/null || :
fi

%post
/sbin/chkconfig --add nfs
/sbin/chkconfig --add nfslock
/sbin/chkconfig --add rpcidmapd
/sbin/chkconfig --add rpcgssd
/sbin/chkconfig --add rpcsvcgssd
# Make sure statd used the correct uid/gid.
if [ -f /var/lock/subsys/nfslock ]; then
	%{_initscriptdir}/nfslock stop > /dev/null
	chown -R rpcuser:rpcuser /var/lib/nfs/statd
	%{_initscriptdir}/nfslock start > /dev/null
else
	chown -R rpcuser:rpcuser /var/lib/nfs/statd
fi

%preun
if [ "$1" = "0" ]; then
    %{_initscriptdir}/nfs condrestart
    %{_initscriptdir}/rpcgssd condrestart
    %{_initscriptdir}/rpcidmapd condrestart
    %{_initscriptdir}/nfslock condrestart
    /sbin/chkconfig --del rpcidmapd
    /sbin/chkconfig --del rpcgssd
    /sbin/chkconfig --del rpcsvcgssd
    /sbin/chkconfig --del nfs
    /sbin/chkconfig --del nfslock
    /usr/sbin/userdel rpcuser 2>/dev/null || :
    /usr/sbin/groupdel rpcuser 2>/dev/null || :
    /usr/sbin/userdel nfsnobody 2>/dev/null || :
    rm -rf /var/lib/nfs/statd
    rm -rf /var/lib/nfs/v4recovery
fi

%postun
if [ "$1" -ge 1 ]; then
	%{_initscriptdir}/rpcidmapd condrestart > /dev/null
	%{_initscriptdir}/rpcgssd condrestart > /dev/null
	%{_initscriptdir}/nfs condrestart > /dev/null
	%{_initscriptdir}/nfslock condrestart > /dev/null
fi

%triggerpostun -- nfs-server
/sbin/chkconfig --add nfs

%triggerpostun -- knfsd
/sbin/chkconfig --add nfs

%triggerpostun -- knfsd-clients
/sbin/chkconfig --add nfslock

%files
%defattr(-,root,root)
%config %{_initscriptdir}/nfs
%config %{_initscriptdir}/rpcidmapd
%config %{_initscriptdir}/rpcgssd
%config %{_initscriptdir}/rpcsvcgssd
%config(noreplace) /etc/sysconfig/nfs
%dir /var/lib/nfs/v4recovery
%dir /var/lib/nfs/rpc_pipefs
%dir /var/lib/nfs
%dir %attr(700,rpcuser,rpcuser) /var/lib/nfs/statd
%dir %attr(700,rpcuser,rpcuser) /var/lib/nfs/statd/sm
%config(noreplace) /var/lib/nfs/xtab
%config(noreplace) /var/lib/nfs/etab
%config(noreplace) /var/lib/nfs/rmtab
%config(noreplace) /var/lib/nfs/state
%doc linux-nfs/*
/sbin/rpc.statd
/usr/sbin/exportfs
/usr/sbin/nfsstat
/usr/sbin/rpcdebug
/usr/sbin/rpc.mountd
/usr/sbin/rpc.nfsd
/usr/sbin/showmount
/usr/sbin/rpc.idmapd
/usr/sbin/rpc.gssd
/usr/sbin/rpc.svcgssd
/usr/sbin/gss_clnt_send_err
/usr/sbin/gss_destroy_creds
/usr/sbin/sm-notify
/usr/sbin/start-statd
%{_mandir}/*/*
%config %{_initscriptdir}/nfslock

%attr(4755,root,root)   /sbin/mount.nfs
%attr(4755,root,root)   /sbin/mount.nfs4
%attr(4755,root,root)   /sbin/umount.nfs
%attr(4755,root,root)   /sbin/umount.nfs4

%changelog
* Sun Mar 15 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.1.4-3m)
- import 3 patches (Patch10-12) from Fedora 10 (1.1.4-8)
-- fix tcp wrapper

* Mon Feb  2 2009 NAKAYA Toshiharu <nakaya@momonga-linux.org>
- (1.1.4-2m)
- [SECURITY] CVE-2009-0180
- import security patches (Patch8,9) from Fedora 10 (1.1.4-6)

* Tue Oct 21 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.4-1m)
- [SECURITY] CVE-2008-4552
- update to 1.1.4

* Thu Apr 03 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.1.2-3m)
- rebuild against gcc43

* Mon Mar 31 2008 TABUCHI Takaaki <tab@momonga-linux.org>
- (1.1.2-2m)
- add BuildRequires: nfs-utils-lib # for checking for nfs4_init_name_mapping in -lnfsidmap... no

* Sat Mar 22 2008 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (1.1.2-1m)
- update 1.1.2
- patchs copied from fc devel:
  update Patch06: nfs-utils-1.1.0-exportfs-man-update.patch
  add    Patch07: nfs-utils-1.1.2-multi-auth-flavours.patch

* Sun Mar  2 2008 Mitsuru Shimamura <smbd@momonga-linux.org>
- (1.1.1-2m)
- require newer version of nfs-utils-libs

* Tue Feb 26 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.1.1-1m)
- update 1.1.1
- use libgssglue
- rebuild against openldap-2.4.8

* Wed Feb 13 2008 Yohsuke Ooi <meke@momonga-linux.org>
- (1.1.0-7m)
- %%NoSource -> NoSource

* Sat Jan  5 2008 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.0-6m)
- rebuild against libevent-1.4.1-0.1.1m
- import some patches from Fedora devel

* Sun Oct 14 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.0-5m)
- rebuild against libevent-1.3e

* Fri Sep 21 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.0-4m)
- rebuild against libevent-1.3d

* Thu Aug 16 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.1.0-3m)
- added condstop to all the initscripts again

* Thu Aug 16 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.1.0-2m)
- sync with fc-devel (nfs-utils-1_1_0-3_fc8)
-- update init scripts

* Thu Aug 16 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.1.0-1m)
- update to 1.1.0 (sync with FC-devel)
- rebuild against libevent-1.3c

* Wed Aug  1 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.12-5m)
- fixed bugs in %%{_initscriptdir}/{nfs,nfslock} so that %%postun will not fail.

* Wed Jun 20 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (1.0.12-4m)
- stop auto start

* Sun Jun  3 2007 NARITA Koichi <pulsar@momonga-linux.org>
- (1.0.12-3m)
- rebuild against libevent-1.3b

* Wed May 30 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.12-2m)
- sync fc-devel (nfs-utils-1_0_12-7_fc7)

* Mon May 21 2007 Hiromasa YOSHIMOTO <y@momonga-linux.org>
- (1.0.12-1m)
- sync fc-devel 1.0.12

* Thu Feb 22 2007 Yohsuke Ooi <meke@momonga-linux.org>
- (1.0.10-2m)
- sync fc-devel
-- add cache FS patch

* Wed Feb 21 2007 Mitsuru Shimamura <smbd@momonga-linux.org>
- (1.0.10-1m)
- up to 1.0.10
- rebuild against libevent 1.3a
- rebuild against nfs-utils-libs 1.0.10

* Fri Jul 28 2006 Ichiro Nakai <ichiro@n.email.ne.jp>
- (1.0.8-2m)
- stop all daemon for stable release

* Fri Jun  9 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.8-1m)
- sync with fc

* Sat Jan 14 2006 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.7-1m)
- sync with fc-devel
- enable nfs v4

* Thu Jan 12 2006 Dai OKUYAMA <dai@ouchi.nahi.to>
- (1.0.6-8m)
- build fix for rquotad

* Mon Jul 25 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-7m)
- modify nfs.init

* Wed Jul 20 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-6m)
- revert 1.0.6-2m

* Sun Apr 17 2005 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.6-5m)
- stop rpcidmapd rpcgssd nfslock

* Sat Apr  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.6-4m)
- ummm, who's gonna mount /var/lib/nfs/rpc_pipefs?

* Wed Mar  9 2005 Toru Hoshina <t@momonga-linux.org>
- (1.0.6-3m)
- sync with FC3(1.0.6-52).
- nfs-utils-1.0.6-statddos_quotabuf.patch and
  nfs-utils-1.0.6-auth_reload.patch is applied as another name.

* Wed Dec  8 2004 TAKAHASHI Tamotsu <tamo>
- (1.0.6-2m)
- apply some of UBUNTU patches
 - Patch0: nfs-utils-1.0.6-statddos_quotabuf.patch
  (CAN-2004-1014: ignore SIGPIPE to fix a DoS vulnerability)
  (CAN-2004-0946: do not use memcpy to fix a buffer overflow on 64 bit platforms)
 - Patch1: nfs-utils-1.0.6-auth_reload.patch
  (call auth_reload more often)

* Sun Aug 29 2004 YAMAZAKI Makoto <zaki@zakky.org>
- (1.0.6-1m)
- updated to 1.0.6

* Wed Jul 21 2004 Masahiro Takahata <takahata@momonga-linux.org>
- (1.0.3-5m)
- add uid/gid

* Wed Mar 31 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-4m)
- revised spec. rpc.rquotad belongs quota package.

* Thu Mar 25 2004 Toru Hoshina <t@momonga-linux.org>
- (1.0.3-3m)
- revised spec for rpm 4.2.

* Wed Jul 16 2003 YAMAZAKI Makoto <uomaster@nifty.com>
- (1.0.3-2m)
- add nfsstat-overflow.patch

* Tue Jun  3 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (1.0.3-1m)
  update to 1.0.3

* Wed Oct 24 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.3.3-8k)
- modify rpc.statd location to /sbin on init script

* Fri Oct 19 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-6k)
- require quota 3.0.1
- move rpc.statd to /sbin.

* Fri Oct 12 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-4k)
- revised nfslock.init to use /usr/sbin/rpc.statd instead of /sbin...

* Sat Sep 29 2001 Toru Hoshina <t@kondara.org>
- (0.3.3-2k)
- nfs.statd...

* Fri Apr 13 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.3.1-2k)
- backport from Jirai

* Fri Apr 13 2001 YAMAGUCHI Kenji <yamk@kondara.org>
- (0.3.1-3k)
- upgrade to 0.3.1
- change source URL and URL: tag.
- remove rpc.statd, rpc.lockd (kernels >= 2.2.18+ have automatic NFS lock)
- enable NFSv3

* Thu Mar 15 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.2.1-9k)
- rebuild against glibc-2.2.2 and add nfs-utils.glibc222.time.patch

* Sat Feb  3 2001 MATSUDA, Daiki <dyky@df-usa.com>
- (0.2.1-7k)
- rebuild againt rpm-3.0.5-39k

* Tue Nov 28 2000 Toru Hoshina <toru@df-usa.com>
- use _initscriptdir macro to keep backword compatibility.

* Sun Nov 19 2000 AYUHANA Tomonori <l@kondara.org>
- (0.2.1-1k)
- upgrade 0.1.9.1-3k to 0.2.1-1k
- remove Distribution
- obey FHS

* Wed Jul 19 2000 AYUHANA Tomonori <l@kondara.org>
- (0.1.9.1-1k)
- ported from RedHat-6.2 Updates
- Be a NoSrc :-P
- rebuild against glibc-2.1.91, X-4.0, rpm-3.0.5
- SPEC fixed ( Distribution, BuildRoot, URL, Source )
- use %configure
- add SBINDIR and MAN*DIR at make install

* Mon Jul 17 2000 Matt Wilson <msw@redhat.com>
- 0.1.9.1
- remove patch0, has been integrated upstream

* Wed Feb  9 2000 Bill Nottingham <notting@redhat.com>
- the wonderful thing about triggers, is triggers are wonderful things...

* Thu Feb 03 2000 Cristian Gafton <gafton@redhat.com>
- switch to nfs-utils as the base tree
- fix the statfs patch for the new code base
- single package that obsoletes everything we had before (if I am to keep
  some traces of my sanity with me...)

* Mon Jan 17 2000 Preston Brown <pbrown@redhat.com>
- use statfs syscall instead of stat to determinal optimal blksize
